import * as React from "react";

import * as CounterComponent from "./components/counter";
import * as CounterReducer from "./reducers/counter"

import * as ReactDOM from 'react-dom'
import { Provider } from 'react-redux'
import { createStore } from 'redux'

const store = createStore(CounterReducer.counter);
const rootEl = document.getElementById("content");

export class Application extends React.Component<any, any>{

    constructor() {
        super();

        store.subscribe(() => {
            ReactDOM.render(
                <Application />,
                rootEl
            )
        })
    }

    render() {
        return (
            <Provider store={store}>
                <CounterComponent.Counter
                    compiler="TypeScript"
                    framework="React"
                    value={store.getState()}
                    onIncrement={() => store.dispatch({ type: 'INCREMENT' })}
                    onDecrement={() => store.dispatch({ type: 'DECREMENT' })}
                    />
            </Provider>
        );
    }
}

ReactDOM.render(
    <Application />,
    rootEl
)