import * as React from "react";
import { PropTypes } from 'react';

export interface CounterProps {
    compiler: string,
    framework: string,
    onIncrement: () => { type: string; },
    onDecrement: () => { type: string; },
    value: number
}

export interface CounterState { }

// The counter component. Extended from a react component.
export class Counter extends React.Component<CounterProps, CounterState>
{
    static contextTypes = {
        store:PropTypes.any
    };

    constructor(props: CounterProps,context:CounterState) {
        super(props, context);
        console.log(context['store'],props['store']);
    }

    componentDidMount() {
        const {store} = this.context;
        console.log('store:', store);
    }

    render() {
        // console.log('store:', this.context.store);
        return (
            <p>
                Clicked: {this.props.value} times !
                {' '}
                <button onClick={this.props.onIncrement}>
                    +
                </button>
                {' '}
                <button onClick={this.props.onDecrement}>
                    -
                </button>
            </p>
        );
    }
}
